/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the OperationRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OperationRequest{}

// OperationRequest struct for OperationRequest
type OperationRequest struct {
	Name      *string                           `json:"name,omitempty"`
	Output    *string                           `json:"output,omitempty"`
	Union     NullableOperationRequestUnion     `json:"union,omitempty"`
	LeftJoin  NullableOperationRequestLeftJoin  `json:"left_join,omitempty"`
	InnerJoin NullableOperationRequestInnerJoin `json:"inner_join,omitempty"`
	View      NullableOperationRequestView      `json:"view,omitempty"`
	Limit     NullableOperationRequestLimit     `json:"limit,omitempty"`
	Sort      NullableOperationRequestSort      `json:"sort,omitempty"`
	Filter    NullableOperationRequestFilter    `json:"filter,omitempty"`
	Format    NullableOperationRequestFormat    `json:"format,omitempty"`
}

// NewOperationRequest instantiates a new OperationRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOperationRequest() *OperationRequest {
	this := OperationRequest{}
	return &this
}

// NewOperationRequestWithDefaults instantiates a new OperationRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOperationRequestWithDefaults() *OperationRequest {
	this := OperationRequest{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *OperationRequest) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OperationRequest) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *OperationRequest) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *OperationRequest) SetName(v string) {
	o.Name = &v
}

// GetOutput returns the Output field value if set, zero value otherwise.
func (o *OperationRequest) GetOutput() string {
	if o == nil || IsNil(o.Output) {
		var ret string
		return ret
	}
	return *o.Output
}

// GetOutputOk returns a tuple with the Output field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OperationRequest) GetOutputOk() (*string, bool) {
	if o == nil || IsNil(o.Output) {
		return nil, false
	}
	return o.Output, true
}

// HasOutput returns a boolean if a field has been set.
func (o *OperationRequest) HasOutput() bool {
	if o != nil && !IsNil(o.Output) {
		return true
	}

	return false
}

// SetOutput gets a reference to the given string and assigns it to the Output field.
func (o *OperationRequest) SetOutput(v string) {
	o.Output = &v
}

// GetUnion returns the Union field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationRequest) GetUnion() OperationRequestUnion {
	if o == nil || IsNil(o.Union.Get()) {
		var ret OperationRequestUnion
		return ret
	}
	return *o.Union.Get()
}

// GetUnionOk returns a tuple with the Union field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationRequest) GetUnionOk() (*OperationRequestUnion, bool) {
	if o == nil {
		return nil, false
	}
	return o.Union.Get(), o.Union.IsSet()
}

// HasUnion returns a boolean if a field has been set.
func (o *OperationRequest) HasUnion() bool {
	if o != nil && o.Union.IsSet() {
		return true
	}

	return false
}

// SetUnion gets a reference to the given NullableOperationRequestUnion and assigns it to the Union field.
func (o *OperationRequest) SetUnion(v OperationRequestUnion) {
	o.Union.Set(&v)
}

// SetUnionNil sets the value for Union to be an explicit nil
func (o *OperationRequest) SetUnionNil() {
	o.Union.Set(nil)
}

// UnsetUnion ensures that no value is present for Union, not even an explicit nil
func (o *OperationRequest) UnsetUnion() {
	o.Union.Unset()
}

// GetLeftJoin returns the LeftJoin field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationRequest) GetLeftJoin() OperationRequestLeftJoin {
	if o == nil || IsNil(o.LeftJoin.Get()) {
		var ret OperationRequestLeftJoin
		return ret
	}
	return *o.LeftJoin.Get()
}

// GetLeftJoinOk returns a tuple with the LeftJoin field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationRequest) GetLeftJoinOk() (*OperationRequestLeftJoin, bool) {
	if o == nil {
		return nil, false
	}
	return o.LeftJoin.Get(), o.LeftJoin.IsSet()
}

// HasLeftJoin returns a boolean if a field has been set.
func (o *OperationRequest) HasLeftJoin() bool {
	if o != nil && o.LeftJoin.IsSet() {
		return true
	}

	return false
}

// SetLeftJoin gets a reference to the given NullableOperationRequestLeftJoin and assigns it to the LeftJoin field.
func (o *OperationRequest) SetLeftJoin(v OperationRequestLeftJoin) {
	o.LeftJoin.Set(&v)
}

// SetLeftJoinNil sets the value for LeftJoin to be an explicit nil
func (o *OperationRequest) SetLeftJoinNil() {
	o.LeftJoin.Set(nil)
}

// UnsetLeftJoin ensures that no value is present for LeftJoin, not even an explicit nil
func (o *OperationRequest) UnsetLeftJoin() {
	o.LeftJoin.Unset()
}

// GetInnerJoin returns the InnerJoin field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationRequest) GetInnerJoin() OperationRequestInnerJoin {
	if o == nil || IsNil(o.InnerJoin.Get()) {
		var ret OperationRequestInnerJoin
		return ret
	}
	return *o.InnerJoin.Get()
}

// GetInnerJoinOk returns a tuple with the InnerJoin field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationRequest) GetInnerJoinOk() (*OperationRequestInnerJoin, bool) {
	if o == nil {
		return nil, false
	}
	return o.InnerJoin.Get(), o.InnerJoin.IsSet()
}

// HasInnerJoin returns a boolean if a field has been set.
func (o *OperationRequest) HasInnerJoin() bool {
	if o != nil && o.InnerJoin.IsSet() {
		return true
	}

	return false
}

// SetInnerJoin gets a reference to the given NullableOperationRequestInnerJoin and assigns it to the InnerJoin field.
func (o *OperationRequest) SetInnerJoin(v OperationRequestInnerJoin) {
	o.InnerJoin.Set(&v)
}

// SetInnerJoinNil sets the value for InnerJoin to be an explicit nil
func (o *OperationRequest) SetInnerJoinNil() {
	o.InnerJoin.Set(nil)
}

// UnsetInnerJoin ensures that no value is present for InnerJoin, not even an explicit nil
func (o *OperationRequest) UnsetInnerJoin() {
	o.InnerJoin.Unset()
}

// GetView returns the View field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationRequest) GetView() OperationRequestView {
	if o == nil || IsNil(o.View.Get()) {
		var ret OperationRequestView
		return ret
	}
	return *o.View.Get()
}

// GetViewOk returns a tuple with the View field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationRequest) GetViewOk() (*OperationRequestView, bool) {
	if o == nil {
		return nil, false
	}
	return o.View.Get(), o.View.IsSet()
}

// HasView returns a boolean if a field has been set.
func (o *OperationRequest) HasView() bool {
	if o != nil && o.View.IsSet() {
		return true
	}

	return false
}

// SetView gets a reference to the given NullableOperationRequestView and assigns it to the View field.
func (o *OperationRequest) SetView(v OperationRequestView) {
	o.View.Set(&v)
}

// SetViewNil sets the value for View to be an explicit nil
func (o *OperationRequest) SetViewNil() {
	o.View.Set(nil)
}

// UnsetView ensures that no value is present for View, not even an explicit nil
func (o *OperationRequest) UnsetView() {
	o.View.Unset()
}

// GetLimit returns the Limit field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationRequest) GetLimit() OperationRequestLimit {
	if o == nil || IsNil(o.Limit.Get()) {
		var ret OperationRequestLimit
		return ret
	}
	return *o.Limit.Get()
}

// GetLimitOk returns a tuple with the Limit field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationRequest) GetLimitOk() (*OperationRequestLimit, bool) {
	if o == nil {
		return nil, false
	}
	return o.Limit.Get(), o.Limit.IsSet()
}

// HasLimit returns a boolean if a field has been set.
func (o *OperationRequest) HasLimit() bool {
	if o != nil && o.Limit.IsSet() {
		return true
	}

	return false
}

// SetLimit gets a reference to the given NullableOperationRequestLimit and assigns it to the Limit field.
func (o *OperationRequest) SetLimit(v OperationRequestLimit) {
	o.Limit.Set(&v)
}

// SetLimitNil sets the value for Limit to be an explicit nil
func (o *OperationRequest) SetLimitNil() {
	o.Limit.Set(nil)
}

// UnsetLimit ensures that no value is present for Limit, not even an explicit nil
func (o *OperationRequest) UnsetLimit() {
	o.Limit.Unset()
}

// GetSort returns the Sort field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationRequest) GetSort() OperationRequestSort {
	if o == nil || IsNil(o.Sort.Get()) {
		var ret OperationRequestSort
		return ret
	}
	return *o.Sort.Get()
}

// GetSortOk returns a tuple with the Sort field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationRequest) GetSortOk() (*OperationRequestSort, bool) {
	if o == nil {
		return nil, false
	}
	return o.Sort.Get(), o.Sort.IsSet()
}

// HasSort returns a boolean if a field has been set.
func (o *OperationRequest) HasSort() bool {
	if o != nil && o.Sort.IsSet() {
		return true
	}

	return false
}

// SetSort gets a reference to the given NullableOperationRequestSort and assigns it to the Sort field.
func (o *OperationRequest) SetSort(v OperationRequestSort) {
	o.Sort.Set(&v)
}

// SetSortNil sets the value for Sort to be an explicit nil
func (o *OperationRequest) SetSortNil() {
	o.Sort.Set(nil)
}

// UnsetSort ensures that no value is present for Sort, not even an explicit nil
func (o *OperationRequest) UnsetSort() {
	o.Sort.Unset()
}

// GetFilter returns the Filter field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationRequest) GetFilter() OperationRequestFilter {
	if o == nil || IsNil(o.Filter.Get()) {
		var ret OperationRequestFilter
		return ret
	}
	return *o.Filter.Get()
}

// GetFilterOk returns a tuple with the Filter field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationRequest) GetFilterOk() (*OperationRequestFilter, bool) {
	if o == nil {
		return nil, false
	}
	return o.Filter.Get(), o.Filter.IsSet()
}

// HasFilter returns a boolean if a field has been set.
func (o *OperationRequest) HasFilter() bool {
	if o != nil && o.Filter.IsSet() {
		return true
	}

	return false
}

// SetFilter gets a reference to the given NullableOperationRequestFilter and assigns it to the Filter field.
func (o *OperationRequest) SetFilter(v OperationRequestFilter) {
	o.Filter.Set(&v)
}

// SetFilterNil sets the value for Filter to be an explicit nil
func (o *OperationRequest) SetFilterNil() {
	o.Filter.Set(nil)
}

// UnsetFilter ensures that no value is present for Filter, not even an explicit nil
func (o *OperationRequest) UnsetFilter() {
	o.Filter.Unset()
}

// GetFormat returns the Format field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationRequest) GetFormat() OperationRequestFormat {
	if o == nil || IsNil(o.Format.Get()) {
		var ret OperationRequestFormat
		return ret
	}
	return *o.Format.Get()
}

// GetFormatOk returns a tuple with the Format field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationRequest) GetFormatOk() (*OperationRequestFormat, bool) {
	if o == nil {
		return nil, false
	}
	return o.Format.Get(), o.Format.IsSet()
}

// HasFormat returns a boolean if a field has been set.
func (o *OperationRequest) HasFormat() bool {
	if o != nil && o.Format.IsSet() {
		return true
	}

	return false
}

// SetFormat gets a reference to the given NullableOperationRequestFormat and assigns it to the Format field.
func (o *OperationRequest) SetFormat(v OperationRequestFormat) {
	o.Format.Set(&v)
}

// SetFormatNil sets the value for Format to be an explicit nil
func (o *OperationRequest) SetFormatNil() {
	o.Format.Set(nil)
}

// UnsetFormat ensures that no value is present for Format, not even an explicit nil
func (o *OperationRequest) UnsetFormat() {
	o.Format.Unset()
}

func (o OperationRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OperationRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.Output) {
		toSerialize["output"] = o.Output
	}
	if o.Union.IsSet() {
		toSerialize["union"] = o.Union.Get()
	}
	if o.LeftJoin.IsSet() {
		toSerialize["left_join"] = o.LeftJoin.Get()
	}
	if o.InnerJoin.IsSet() {
		toSerialize["inner_join"] = o.InnerJoin.Get()
	}
	if o.View.IsSet() {
		toSerialize["view"] = o.View.Get()
	}
	if o.Limit.IsSet() {
		toSerialize["limit"] = o.Limit.Get()
	}
	if o.Sort.IsSet() {
		toSerialize["sort"] = o.Sort.Get()
	}
	if o.Filter.IsSet() {
		toSerialize["filter"] = o.Filter.Get()
	}
	if o.Format.IsSet() {
		toSerialize["format"] = o.Format.Get()
	}
	return toSerialize, nil
}

type NullableOperationRequest struct {
	value *OperationRequest
	isSet bool
}

func (v NullableOperationRequest) Get() *OperationRequest {
	return v.value
}

func (v *NullableOperationRequest) Set(val *OperationRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableOperationRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableOperationRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOperationRequest(val *OperationRequest) *NullableOperationRequest {
	return &NullableOperationRequest{value: val, isSet: true}
}

func (v NullableOperationRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOperationRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
